#include "resource.h"
#pragma once

#define prohodan 0 // cvor je prohodan
#define neprohodan 1 // cvor nije prohodan
#define pronadjen 2 // put je pronadjen
#define nepostoji 3 // put ne postoji
#define uZatvorenojListi 4 // cvor je u zatvorenoj listi
#define uOtvorenojListi 5 // cvor je u otvorenoj listi
#define nijeUListi 6 // cvor nije u listi

// Cvorovi mogu imati i neke boje
#define crvena 7
#define crna 8
#define zelena 9
#define plava 10
#define zuta 11

// Struktura koja cuva niz tacaka
struct Tacke
{ 
	UINT x, y; // koordinate tacaka
	Tacke(UINT xx=-1, UINT yy=-1){x=xx; y=yy;}
};

// Klasa koja cuva cvorove u matrici
class Cvor
{
	Tacke lokacija; // lokacija na mapi
	int F, // G + H
		G, // Vrednost puta od pocetka do ovog cvora, gde je
		   // hor./ver. kretanje = 10, a dijag. = 14
		H; // Procenjeni broj cvorova od ovog cvora do odredista (Heuristika),
		   // samo hor./ver. kretanje
	Tacke roditelj; // roditelj
	UINT status; // status na mapi = prohodan/neprohodan
	UINT uListi; // u kojoj je listi cvor = otvorenoj/zatvorenoj/nijeulisti
	UINT boja; // Boja cvora (predefinisana)
public:
	Cvor(void);
	Cvor(UINT xx, UINT yy);
	Cvor(UINT xx, UINT yy, UINT sta);
	Cvor(UINT xx, UINT yy, UINT sta, UINT bo);
	Cvor(UINT xx, UINT yy, int FF, int GG, int HH, UINT sta, UINT li, UINT bo);
	Cvor(const Cvor &); // konstruktor kopije
	~Cvor(void){}

	Cvor &operator=(const Cvor&); // Dodela vrednosti

	// x
	void upisi_x(UINT xx) { lokacija.x = xx; }
	UINT uzmi_x(void)const { return lokacija.x; }

	// y
	void upisi_y(UINT yy) { lokacija.y = yy; }
	UINT uzmi_y(void)const { return lokacija.y; }

	// F
	void upisi_F(int FF) { F = FF; }
	int uzmi_F(void)const { return F; }

	// G
	void upisi_G(int GG) { G = GG; }
	int uzmi_G(void)const { return G; }

	// H
	void upisi_H(int HH) { H = HH; }
	int uzmi_H(void)const { return H; }

	//Status
	void upisi_status(UINT sta) { status = sta; }
	UINT uzmi_status(void)const { return status; }

	// Roditelj
	void upisi_roditelja(Cvor &rod) { roditelj.x = rod.uzmi_x(); roditelj.y = rod.uzmi_y(); }
	Tacke uzmi_roditelja(void)const { return roditelj; }

	// Lista
	void upisi_listu(UINT li) { uListi = li; }
	UINT uzmi_listu(void)const { return uListi; }

	// Boja
	void upisi_boju(UINT bo) { boja = bo; }
	UINT uzmi_boju(void)const { return boja; }
};